'''
Created on 2014. 4. 15.

@author: kaizen
'''
import time
import serial


class WizFi250SerialCmd(object):

    def __init__(self, comP, baud, timeoutValue):
        self.ser = serial.Serial(comP, baud, timeout = timeoutValue)

    def serialClose(self):
        self.ser.close()
    
    def __del__(self):
        self.serialClose()

    def Write_CMD(self,cmd, resp1, resp2, ngtvResp, loopCnt, opt=1):
        status = False
        resp1_stat = False
        resp2_stat = False

        if( opt == 1 ):
            cmd = cmd + "\r"
        
        self.ser.write(cmd)

        for i in range(loopCnt):
            respData = self.ser.readline()
            if( respData != ""):
                print respData
            
            if( respData.find(resp1) >= 0 ):
                resp1_stat = True
            elif( respData.find(resp2) >= 0):
                resp2_stat = True
            elif( respData.find(ngtvResp) >= 0):
                return False
                
            if( resp1_stat == True and resp2_stat == True):
                status = True
                break
        
        return status
    
    
    def send_data_in_datamode(self,data):
        self.ser.write(data)
    
    def send_data_in_commandmode(self,sock_num, data, debug_print):
        data_length = len(data)
        
        cmd_str = "AT+SSEND=" + str(sock_num) + ",,," + str(data_length)
        
        # debug_print 0: disable, 1: enable
        self.Write_CMD(cmd_str,"", "", "", 0)
        self.ser.write(data)
        self.Write_CMD("","[OK]","", "[ERROR]", 50)
    
    def tcp_connect(self, dest_ip, port, mode):
        if ( mode == 1 ):        #Using Data Mode
            cmd_str = "AT+SCON=O,TCN," + dest_ip + "," + str(port) + ",,1"
        elif ( mode == 0 ):
            cmd_str = "AT+SCON=O,TCN," + dest_ip + "," + str(port) + ",,0"
            
        result = self.Write_CMD(cmd_str,"[OK]", "[CONNECT", "[ERROR]",500)
        
        if ( result == True ):
            print "TCP Connected"
            self.m_conn_status = True
        else:
            print "TCP Disconnected"
            self.m_conn_status = False
            
        return result
        


# if __name__ == '__main__':
#     wizfiCmd = WizFi250SerialCmd('com3', 115200, 1)
#     wizfiCmd.Write_CMD("AT", "OK", "", 100)
    
    
    